      subroutine read_points
c------------------------------------------------------
c     INPUT:
c     iuinp       -> unit file
c     npoints     -> number of consecutive measurements
c                    of some fluctuating quantity
c     init        -> initial value for consecutive measurements
c                    of some fluctuating quantity
c     ntot        -> total number of consecutive measurements
c                    of some fluctuating quantity
c     nsave       -> frequency for data collection
c     OUTPUT:
c     x(npoints)  -> consecutive measurements of some 
c                    fluctuating quantity
c-------------------------------------------------------- 

      use datos, only : npoints, ntot, init, nsave, x, iuinp
      implicit none
      integer :: i, j, k
c
c-----Read x
c
      write(*,*)
      write(*,'(3x,a)') 'STEP1: READING DATA'
      write(*,'(3x,a)') '==================='
      write(*,*)
      if (ntot.gt.(npoints+init)) then
        write(*,'(3x,a,1x,i10)') 'Total number of variables for'
     &                         //' discrete distribution', ntot
      endif
      write(*,'(3x,a,1x,i10)') 'Number of variables for discrete'
     &                       //' distribution', npoints
      if (init.gt.0) then
        write(*,'(3x,a,1x,i10)') 'Initial value for discrete' 
     &                         //' distribution', init
      endif
      if (nsave.gt.1) then
        write(*,'(3x,a,1x,i10)') 'Frequency for data collection', 
     &                            nsave
      endif 
      write(*,*)
      write(*,'(3x,a)') 'Consecutive measurements of some'
     &                //' fluctuating quantity'
      write(*,'(3x,a)') '--------------------------------'
     &                //'---------------------'
      i = 0
      do while (i.lt.init)
        i = i + 1
        read(iuinp,*) 
      enddo
      j = ntot - init
      k = 0
      do i = 1, j
        if (mod(i,nsave).eq.0 .and. k.lt.npoints) then
          k = k + 1
          read(iuinp,*) x(k)
          write(*,'(3x,e18.10)') x(k)
        endif 
      enddo
c
c-----End
c
      return
      end

