      subroutine shellvar
c---------------------------------------------------------------------
      use datos, only : stdin, iuinp, iuwt, npoints, init, nsave, 
     &                  ntot, itype, npont, x, sg, faterr, warning
c.....LOCAL VARIABLES
      implicit none
      logical :: logfinal, Qinput, Qouput, Qread 
      character :: com*350, wrd5*5, fnam*80
      integer :: iunit, ier

c     Initializations
c     ----------------
      logfinal = .false.
      Qinput = .false.  
      Qouput = .false.
      Qread = .false.
c
      do while (.not. logfinal)
        call getlin(com,stdin,6) ! new commands line
        call nxtchn(com,' ',wrd5) ! new key word
        call upper(wrd5) ! capital letters
        if (wrd5.eq.'INPUT') then
c           ---------------
          if (Qinput) then
            call error ('shellvar', 'INPUT command has been defined'
     &               //' previously', faterr)
          endif
          ! data file [integer,default=1]
          call gtipar(com,'unit',iuinp,1)
          if (Qouput .and. iuinp.eq.iuwt) then
            call error ('shellvar', 'iuinp=iuwt', faterr)
          endif
          ! namefile [character]
          call getwrd(com,'name',fnam)
          open (unit=iuinp,file=fnam,status='old',form='formatted')
          Qinput = .true.
        else if (wrd5.eq.'OUTPU') then
c               ----------------
          if (Qouput) then
            call error ('shellvar', 'OUTPUT command has been defined'
     &               //' previously', faterr)
          endif
          ! ouput file [integer,default=2]
          call gtipar(com,'unit',iuwt,2)
          if (Qinput .and. iuwt.eq.iuinp) then
            call error ('shellvar', 'iuwt=iuinp', faterr)
          endif
          ! namefile [character]
          call getwrd(com,'name',fnam)
          open (unit=iuwt,file=fnam,form='formatted')
          Qouput = .true.
        else if (wrd5.eq.'CLOSE') then
c               ----------------       
          if (.not.Qinput .and. .not.Qouput) then
            call error ('shellvar', 'CLOSE command is defined before'
     &                //' INPUT and OUTPUT command', faterr)
          endif
          ! unit [integer,default=1]
          call gtipar(com,'unit',iunit,1)
          if (iunit.eq.iuinp) then
           deallocate (x, stat=ier)
            if (ier.ne.0) then
              call error ('shellvar', 'Cannot deallocate x',
     &                    faterr)
            endif          
            Qinput = .false.
            Qread  = .false.
          else if (iunit.eq.iuwt) then 
            if (itype.eq.1) then 
              deallocate (npont, stat=ier)
              if (ier.ne.0) then
                call error ('shellvar', 'Cannot deallocate npont', 
     &                      faterr)
              endif
            endif
            deallocate (sg, stat=ier)
            if (ier.ne.0) then
              call error ('shellvar', 'Cannot deallocate sg',
     &                     faterr)
            endif
            Qouput = .false.
          else
            call error ('shellvar', 'Wrong unit to close', faterr) 
          endif
          close (unit=iunit)
        else if (wrd5.eq.'READ ') then
c               ----------------
          if (.not.Qinput) then
            call error ('shellvar', 'READ command is defined before'
     &                            //' INPUT command', faterr)
          endif
          ! number of consecutive measurements of some fluctuating 
          ! quantity [integer,default=4]
          call gtipar(com,'npoints',npoints,4)
          if (npoints.lt.4) then
            call error ('shellvar', 'npoints < 4', faterr)
          endif
          if (mod(npoints,2).ne.0) then
            call error ('shellvar', 'mod(npoints,2).ne.0', faterr)
          endif
          allocate (x(npoints), stat=ier)
          if (ier.ne.0) then
            call error ('shellvar', 'Cannot allocate x', faterr)
          endif
          ! Initial value for consecutive measurements of some 
          ! fluctuating quantity [integer,default=0]
          call gtipar(com,'init',init,0)
          if (init.lt.0) then
            call error ('shellvar', 'init < 0', faterr)
          endif
          ! Total number of consecutive measurements of some  
          ! fluctuating quantity [integer,default=npoints+init]
          call gtipar(com,'ntot',ntot,npoints+init)
          if (ntot.lt.(npoints+init)) then
            call error ('shellvar', 'ntot < (npoints+init)', faterr)
          endif
          ! Frequency for data collection [integer,default=1]
          call gtipar(com,'nsave',nsave,1)
          if (nsave.le.0) then
            call error ('shellvar', 'nsave < o = 0', faterr)
          endif 
          if (nsave.gt.1 .and. mod(ntot-init,nsave).ne.0) then
            call error ('shellvar', 'nsave has an incorrect value',
     &                  faterr)
          endif 
          if (nsave.gt.1 .and. (ntot-init)/nsave.lt.npoints) then
            call error ('shellvar', '(ntot-init)/nsave < npoints', 
     &                  faterr)
          endif
          call read_points
          Qread = .true. 
        else if (wrd5.eq.'CALC ') then        
c               ----------------
          if (.not.Qread .or. .not.Qouput) then
            call error ('shellvar', 'CALC command is defined before'
     &                //' READ command and/or OUTPU commnad', faterr)
          endif
          ! Method type (1-> blocking method, 2-> statistical
          ! inefficiency) [integer,default=1]
          call gtipar(com,'type',itype,1)
          if (itype.ne.1 .and. itype.ne.2) then
            call error ('shellvar', 'wrong itype', faterr)
          endif
          if (itype.eq.1) then
            call blocking_method
          else
            call s_routine 
          endif
        else if (wrd5.eq.'END  ') then
c               ---------------
          logfinal = .true.
        else
          call error ('shellvar', 'Unrecognized command', warning)
        endif
     
      enddo

      return
      end
